# cordic_test.awk
# $Id$
# Larry Doolittle, LBNL

# llc-suite Copyright (c) 2004, The Regents of the University of
# California, through Lawrence Berkeley National Laboratory (subject
# to receipt of any required approvals from the U.S. Dept. of Energy).
# All rights reserved.

# Your use of this software is pursuant to a "BSD-style" open
# source license agreement, the text of which is in license.txt
# (md5sum a1e0e81c78f6eba050b0e96996f49fd5) that should accompany
# this file.  If the license agreement is not there, or if you
# have questions about the license, please contact Berkeley Lab's
# Technology Transfer Department at TTD@lbl.gov referring to
# "llc-suite (LBNL Ref CR-1988)"

BEGIN{
  # fs=16384*1.64676
  scale=1.64676
}
!/x/ && !/dumpfile/{
  if ($7==0) {
    a  = $1/65536.0*3.1415926
    xv = ($2*cos(a)-$3*sin(a))*scale
    yv = ($2*sin(a)+$3*cos(a))*scale
    # print $0,xv,yv
    ex = $4-xv
    # ex=$2-cos($1/65536.0*3.1415926)*fs
  } else {
    a  = $1/65536.0*3.1415926
    a2 = atan2($3,$2)*65536/3.1415926 + 65536
    ex  = $6 - a2
    # print $0,a2,ex
  }
  if (ex>emax) emax=ex
  if (ex<emin) emin=ex
  ey = $5-yv
  if (ey>emax) emax=ey
  if (ey<emin) emin=ey
  e2sum = e2sum + ex*ex + ey*ey
  # printf "%s %6.2f %6.2f %6.2f %6.2f\n", $0, e, ey, emax, emin
  n = n+2
  r = sqrt($4*$4+$5*$5);
  if (r>fs) fs=r
}
END{
  printf "test covers %d points, full scale is %d bits\n", n, fs
  if (-emin > emax) emax=-emin
  rms=sqrt(e2sum/n)
  printf "peak error %6.2f bits, %6.4f %%\n", emax, emax*100/fs
  printf "rms  error %6.2f bits, %6.4f %%\n", rms,  rms*100/fs
  if (emax*100/fs > .035 || rms*100/fs > 0.01) {
    print "FAIL"
    exit 1
  } else {
    print "PASS"
  }
}
