% to do:
%   compute latency
%   finish noise characterization, make it pass/fail
%   pretty plots?

if (with_in_fir)
  ss='with';
else
  ss='without';
end
printf('Analysis of %d points, f_IF/f_S = %d/%d, mod = %.3f/%d, %s input FIR\n',
  length(y), num, den, harm, npt, ss); 
t=[1:length(y)]';
z=exp(-i*2*pi*harm*t/npt);
p=mean(y./z);
err=y/p-z;
th=2*pi*num/den;
sinth=sin(th);
rms=sqrt(mean(abs(err).^2));

sig_out=inamp*gain_set*sinth;
rms=sqrt(mean(abs(err).^2));
% expected noise:
noise_in=sqrt(inrms^2+quant_n^2)/inamp;  % rms/full scale
noise_out=noise_in*sqrt(2)/sinth;
if (with_in_fir)
   sig_out=sig_out*sinth;
   noise_out=noise_out/sinth*sqrt(0.5);
end
printf('Output amplitude %.1f, expected %.1f\n', abs(p), sig_out);
printf('Noise/Signal               %.8f, expected %.8f\n',rms,noise_out)

yf=filter(ones(1,cic_n)/cic_n,1,y);
yf=yf(1+cic_n:end);
tf=t(1+cic_n:end);
zf=exp(-i*2*pi*harm*tf/npt);
pf=mean(yf./zf);
errf=yf/pf-zf;
% plot(tf,real(errf),tf,imag(errf))

if (with_in_fir)
   noise_out2=noise_out*sqrt(2)*sqrt(cic_n-.5)/cic_n;
else
   noise_out2=noise_out*sqrt(cic_n)/cic_n;
end
rmsf=sqrt(mean(abs(errf).^2));

printf('Noise/Signal after N=%d CIC %.8f, expected %.8f\n',cic_n,rmsf,noise_out2)

if (rmsf/noise_out2 < 1.2)
   printf('PASS\n');
else
   printf('FAIL\n');
   % exit(1);
end
